unit ImageSizeDialog;

interface

uses Windows, Messages, NLib, NForm, NkvImage;

type
  TImageSizeDlg = class(TModalDlg)
    Image: TNkVImage;
    Width: Integer;
    Height: Integer;
    Update: Boolean;
    procedure WMInitDialog(var Message: TWMInitDialog); message WM_INITDIALOG;
    procedure WMCommand(var Message: TWMCommand); message WM_COMMAND; 
  end;

implementation

{$I dialogid.inc}

procedure TImageSizeDlg.WMInitDialog(var Message: TWMInitDialog);
begin
  Items[IDC_WIDTH].SetText(IStr(Width));
  Items[IDC_HEIGHT].SetText(IStr(Height));
  SetFocus(Items[IDC_WIDTH].Handle);
  Items[IDC_WIDTH].SendMsg(EM_SETSEL, 0, -1); 
  Message.Result := 0;
end;

procedure TImageSizeDlg.WMCommand(var Message: TWMCommand);
var
  w, h: Integer;
begin
  w := SInt(Items[IDC_WIDTH].Text);
  h := SInt(Items[IDC_HEIGHT].Text);
  with Message do
    case ItemID of
      IDC_WIDTH:
        if (GetFocus=Items[IDC_WIDTH].Handle) and (NotifyCode=EN_CHANGE) then
          Items[IDC_HEIGHT].SetText(
            IStr(RoundOff(w * Image.Height / Image.Width)));
      IDC_HEIGHT:
        if (GetFocus=Items[IDC_HEIGHT].Handle) and (NotifyCode=EN_CHANGE) then
          Items[IDC_WIDTH].SetText(
            IStr(RoundOff(h * Image.Width / Image.Height)));
      IDOK, IDCANCEL:
        begin
          Update := ItemID = IDOK;
          Width := w;
          Height := h;
          Result := 1;
          Close;
        end;
    end;
end;

end.

